!*********************************************************************
!*
!*   Floating point Opcodes (temporary values)
!*
!*********************************************************************
!*
%constinteger Nflopcodes=56
!*
%constinteger   FILD =  0
%constinteger    FLD =  1
%constinteger  FISTP =  2
%constinteger   FSTP =  3
%constinteger   FIST =  4
%constinteger    FST =  5
%constinteger  FIADD =  6
%constinteger   FADD =  7
%constinteger  FIMUL =  8
%constinteger   FMUL =  9
%constinteger  FISUB = 10
%constinteger   FSUB = 11
%constinteger FISUBR = 12
%constinteger   FSUBR = 13
%constinteger   FIDIV = 14
%constinteger    FDIV = 15
%constinteger  FIDIVR = 16
%constinteger   FDIVR = 17
%constinteger   FICOM = 18
%constinteger    FCOM = 19
%constinteger  FICOMP = 20
%constinteger   FCOMP = 21
%constinteger  FCOMPP = 22
%constinteger   FADDP = 23
%constinteger   FMULP = 24
%constinteger   FSUBP = 25
%constinteger  FSUBRP = 26
%constinteger   FDIVP = 27
%constinteger  FDIVRP = 28
%constinteger   FLDCW = 29
%constinteger   FSTCW = 30
%constinteger   FSTSW = 31
%constinteger    FTST = 32
%constinteger    FCHS = 33
%constinteger    FLDZ = 34
%constinteger    FLD1 = 35
%constinteger    FABS = 36
%constinteger FDECSTP = 37
%constinteger FRNDINT = 38
%constinteger    FXCH = 39
%constinteger   FSQRT = 41
%constinteger  FLDL2E = 42
%constinteger   F2XM1 = 43
%constinteger  FLDLN2 = 44
%constinteger   FYL2X = 45
%constinteger  FLDLG2 = 46
%constinteger    FSIN = 47
%constinteger    FCOS = 48
%constinteger   FLDPI = 49
%constinteger   FPTAN = 50
%constinteger  FPATAN = 51
%constinteger   FPREM = 52
!*
%conststring(6) %array fopname(0:Nflopcodes)= %c
"  FILD","   FLD"," FISTP","  FSTP","  FIST","   FST"," FIADD","  FADD",
" FIMUL","  FMUL"," FISUB","  FSUB","FISUBR"," FSUBR"," FIDIV","  FDIV",
"FIDIVR"," FDIVR"," FICOM","  FCOM","FICOMP"," FCOMP","FCOMPP"," FADDP",
" FMULP"," FSUBP","FSUBRP"," FDIVP","FDIVRP"," FLDCW"," FSTCW"," FSTSW",
"  FTST","  FCHS","  FLDZ","  FLD1","  FABS","  FDEC","FRNDIN","  FXCH",
"      "," FSQRT","FLDL2E"," F2XM1","FLDLN2"," FYL2X","FLDLG2","  FSIN",
"  FCOS"," FLDPI"," FPTAN","FPATAN"," FPREM",
""(*)
!*
%constshortintegerarray FLOP(0:Nflopcodes) = %c
X'D900',X'D900',X'D903',X'D903',X'D902',X'D902',X'D800',X'D800',
X'D801',X'D801',X'D804',X'D804',X'D805',X'D805',X'D806',X'D806',
X'D807',X'D807',X'D802',X'D802',X'D803',X'D803',X'DED9',X'DEC1',
X'DEC9',X'DEE1',X'DEE9',X'DEF1',X'DEF9',X'D905',X'D907',X'DFE0',
X'D9E4',X'D9E0',X'D9EE',X'D9E8',X'D9E1',X'D9F6',X'D9FC',X'D9C9',
      0,X'D9FA',X'D9EA',X'D9F0',X'D9ED',X'D9F1',X'D9EC',X'D9FE',
X'D9FF',X'D9EB',X'D9F2',X'D9F3',X'D9F8',
0(*)
