%begin
   ! This program tests various combinations of %c, comma and curly bracketed
   ! comments to ensure that the statement continuation rules are followed,
   ! and that the compiler does not differentiate unexpectedly between %c and
   ! comma.

   %integerfn f(%integer x, y)
      %result = 0
   %end
   %integer a, b, c

   ! Test 1
   a = %c
   {......}
   b

   a = f(b,
   {......}
   c)

   ! Test 2
   a = %c {....}
   b

   a = f(b, {....}
   c)

   ! Test 3
   a = %c {....}
   {....}
   b

   a = f(b, {....}
   {....}
   c)

   ! Test 4
   a = %c {....} {....}
   b

   a = f(b, {....} {....}
   c)

   ! Test 5
   a = %c {....} {....}
   {....}
   b

   a = f(b, {....} {....}
   {....}
   c)

   ! Test 6
   a = f(b, %c {....}
   {....}
   c)

   ! Test 7
   a = {....} %c {....}
   {....}
   b

   a = f(b, {....} %c {....}
   {....}
   c)

%end %of %program
