


    /* EPC Imp to C Translation Release 4 Version Apr 95 */


#include "imptoc.h"

/**                                                           cgp502.inc      */
/** 22-08-95 - Added AllowReverseEndianData for Intel special compiler       */
/**                                                           cgp501.inc     */
/** 14/10/93 - base version                                                  */
/***/
/**************************************************************************/
/**    Define constants specific to a given target.                      **/
/**    These should be kept to a minimum - constants defined for all     **/
/**    E-machine 4 code generators should be in cgc.inc                  **/
/**************************************************************************/
/***/
/***/
/** Definition of the source language                                        */
#define IMP 1
#define FORTRAN 2
#define CCOMP 11
#define PASCAL 14
#define MODULA 15
#define PSAL 16
/***/
#define Language IMP
/*%CONSTINTEGER Language=CCOMP                                               */
/*%CONSTINTEGER Language = Fortran                                           */
/***/
/** Definition of any language variant                                       */
#define FORTRAN77 1
#define FORTRAN90 2
#define USLC 3
#define CPP 4
/***/
#define LanguageVariant 0	/* None*/
/***/
/** Definition of the target architecture                                    */
#define SPARC 16
#define M88K 17
#define i860 18
#define VMEPLI 19
#define RS6 23
#define MIPS 24
#define PENTIUM 25
/***/
#define Target PENTIUM
#define ARCH(x) p5##x
/***/
/** Definition of any target architecture variant                            */
#define DRS6000 0
#define SUNOS 1
#define M88100 2	/*generic M88K                     */
#define M88100for88110 3	/*generic M88K scheduled for M88110*/
#define M88110 4	/*M88110                           */
#define R4000 5	/* MIPS R4000 with extra instructions*/
#define POWER 6	/* POwerPC variant of AIX            */
#define PPRO 7	/* PENTIUM PRO VSN OF X86 but new    */
 	/* INSTRS NOY USED TILL PPRO2        */
#define PPRO2 8
/***/
/*%CONSTINTEGER targetvariant = R4000                                        */
extern int targetvariant;
/***/
/***/
#define ADDRESSSIZE 4	/* =8 for 64 bit architecture */
#define BIG 0
#define LITTLE 1
#define TargetEndian LITTLE
/***/
#define Positive 1
#define Negative (-1)
/***/
#define StackDirection Negative
#define ParamDirection Negative
#define CCavailable Positive	/* Is there a CC (+ve)  or do we       */
 	/* have to do everything with barnches */
 	/* Flags reg is sort of CC on Pentium */
/*%CONSTINTEGER Output ASSEMBLER = positive                                  */	/* produce .s (+ve) or .o (-ve) */
#define OutputASSEMBLER Negative	/* produce .s (+ve) or .o (-ve) */
#define exnameprepend ("_")	/* Initial char of C names */
/***/
#define BUILDWITHGS 0	/* #0 to incluse global scheduler*/

#if((Target==SPARC)||(targetvariant==M88110)||(Target==MIPS)||(Target==PENTIUM)) 
#define Directcomplex 1	/* direct complex   */

#else
#define Directcomplex 0	/* indirect complex */

#endif;
#define AllowReverseEndianData 0	/* 0 to ignore extra stuff */
#define MINCODESIZE 0	/*  #0 only for GPT */
/**/
/* Define the abi required                                                   */
/**/
#define Vdot4ABI 0	/* Unix 5.4 ABI */
#define AIXABI 1	/* AIX or Poweropen */
#define SunsoftABI 2	/* Sunsoft variant of 5.4 used by solaris */
#define ADIABI 3	/* ADIs old coff variant of Poweropen */
#define DGUXABI 4	/* DGs version of 5.4 */
#define LynxOS 5	/* Lynx (coff) via assembler only */
#define NTABI 6	/* Nt-windows conventions */
 
#define TargetABI Vdot4ABI
#define ElfputinC 0	/* Positive for C versionn */
/***/
/****************************** end of cgp5.inc ********************************/
/***/
 

/* end of automatic translation */

